/**********************************************************************
 *HY16F188
 * main.c
 * Created on:2013/12/08
 * Maintenance:2014/10/01
 * --------------------------------------------------------------------
 * Release 1.0.0
 * Program Description:
 * --------------------
 *
 * ---------
 *          |              --------------------
 *    PT2.0 | SDA ---> SDA | LCD Drive HY2613 |
 *    PT2.1 | SCK ---> SCK --------------------
 *     GND  |
 *          |
 * ---------
 **********************************************************************/
/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "HY16F188.h"
#include "System.h"
#include "DrvGPIO.h"
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "DrvCLOCK.h"
#include "DrvTimer.h"
#include "DrvADC.h"
#include "DrvPMU.h"
#include "DrvCMP.h"
#include "HY2613.h"
#include "my define.h"
#include "DrvFlash.h"
/*----------------------------------------------------------------------------*/
/* STRUCTURES                                                                 */
/*----------------------------------------------------------------------------*/
typedef union _MCUSTATUS
{
  char  _byte;
  struct
  {
    unsigned b_ADCdone:1;
    unsigned b_TMAdone:1;
    unsigned b_TMBdone:1;
    unsigned b_TMC0done:1;
    unsigned b_TMC1done:1;
    unsigned b_RTCdone:1;
    unsigned b_UART_TxDone:1;
    unsigned b_UART_RxDone:1;
  };
} MCUSTATUS;

/*----------------------------------------------------------------------------*/
/* DEFINITIONS                                                                */
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/* Global CONSTANTS                                                           */
/*----------------------------------------------------------------------------*/
MCUSTATUS  MCUSTATUSbits;
extern unsigned char seg[16];
/*----------------------------------------------------------------------------*/
/* Function PROTOTYPES                                                        */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num);
void Ini_Touch(void);
void Initial_ALL(void);
void InitalADC(void);
void scalse_cn(void);
void AD01(void);
int ScanKey4(unsigned int TCH);
void touch_ct(void);
void g1(void);

void LCD_DATA_DISPLAY(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY1(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY2(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY3(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY4(unsigned int LcdBuffer);

/*----------------------------------------------------------------------------*/
/* Main Function                                                              */
/*----------------------------------------------------------------------------*/
int main(void)
{
	Ini_Touch();
	InitalADC();
	Initial_ALL();
	InitalI2C();
	Ini_Display();
	ClearLCDframe();

	MCUSTATUSbits._byte = 0;
	pass=ReadWord(0x801c);							//P_O_Flashtե
	if(pass==0x11100)
	{
		  decimal=ReadWord(0x8004);						//AŪUե
	 	  ADnum=ReadWord(0x8008);
	 	  resolution=ReadWord(0x800c);
	 	  ADzero=ReadWord(0x8010);
	 	  ADcn=ReadWord(0x8014);
	 	  cn=ReadWord(0x8018);
	 	  gain=ReadWord(0x8030);
		  threh0=ReadWord(0x802c);
		  threh1=ReadWord(0x8020);
		  threh2=ReadWord(0x8024);
		  threh3=ReadWord(0x8028);
	}
	else
	{
		touch_ct();
		   //threh0=238;									//TOtouch key`A֭
		   //threh1=153;
		   //threh2=143;
		   //threh3=111;
		   scalse_cn();									//IsեƵ{
	}




  DisplayHYcon();
  while(1)
    {

  	  pmu_00=0xff00ff00;			//N\(ٹq)
  	  cmp_00=0xff00;
  	  cmp_04=0xff00ff00;
  	  asm("NOP");
  	  clk_08=0xff00ff0d;			//t_AϥΧCt(ٹq)
  	  Delay(0x100);
  	  clk_00=0xff00ff00;
  	  sys_04=0xff10;
  	  asm("standby 0");
  	  asm("NOP");
  	  DrvADC_Disable();				//ADC\(ٹq)

  	  if(t==1)					//(t=1NTMAwiJ_)
  	  {
  		  t=0;					//CPU
  		  pmu_00=0x03031b1b;	//}Ҥ\(}touch\)
  		  cmp_00=0x13c3c;
  		  cmp_04=0x101d3d3;

  		  clk_00=0xff01;		//}Ұt
  		  clk_08=0xff4c;
  		  TCH=0;ScanKey4(TCH);	//ytouch1O_QUAtouch1QULED
  		  if(LED>=1)
  		  {
  			  DrvADC_Enable();	//}ADC\
  			  DisplayHYcon();;	//ADCíwHYCON
  			  //Delay(0xf0000);
  			  LED=0;					//CҰʡA|b@sI

  			  AD01();
  			  g=average-ADzero;
  			  if(g<70)					//ADDȻPWsIۮt70H۰ʧssI
  			  {
  				  c=10;
  				  while(c)
  				  {
  					AD01();
  					ADzero=average;
  					Delay(0xf000);
  					AD01();
  					g=ADzero-average;									//s⦸ۦPhnext+1
  					if(g==0)
  					{
  						next++;											//nextۦP3hP_IsI
  					}
  					else {next=0;}
  					if(next>3) c=0;
  				  }
  				  ADzero=average;
  			  }

  			  ClearLCDframe();
  			  while(1)
  			  {
  				  g1();							//IsGtƵ{
  				  if(LED>=10)					//tocuh1ɶƫLED[15ɡA}ūܡAAiJٹqA
  				  {
  					  LED=0;
  					  ClearLCDframe();			//MLCD
  					  Delay(0xFF00);
  					  //LCD_DATA_DISPLAY(ADzero);
  					  //Delay(0xf1000);
  					  goto bb;					//LCDǳƶiJٹqҦ
  				  }
  				  TCH=1;ScanKey4(TCH);			//ytouch key2
  				  if(LED<=-10)
  				  {
  					  LED=0;
  					  if(bb==0) bb=1;			//ADȺX=1
  					  else bb=0;				//A@h
  				  }
  				  g1();							//IsGtƵ{
  				  TCH=3;ScanKey4(TCH);			//ytouch key4
  				  if(c<=-10)
  				  {
  					  scalse_cn();				//IsեƵ{
  				  }
  				  g1();							//IsGtƵ{
  				  TCH=2;ScanKey4(TCH);			//ytouch key3
  				  if(enter>=10)
  				  {
  					  enter=0;
  					  if(tare==0) tare=1;					//xXе1
  					  else tare=0;							//A@hx
  					  tareg=g;								//x
  				  }
  				  Delay(0x2000);
  				  TCH=0;ScanKey4(TCH);			//ytouch key1
  			  }
  		  }
  	  }
  	  t=0;
  bb:	  ClearLCDframe();							//MLCD
    }




  while(1);
  return 0;
}
void g1(void)
{
	unsigned long long buu;								//tμȦs
	buu=0;
	buu=buu-1;
	  AD01();									//IsADCƵ{

	  if(bb==1) LCD_DATA_DISPLAY(average);		//AD

	  else
	  {
		  switch(decimal)						//P_pIơAõ۹ƭ
		  {
		  	  case 4:{dou=100;}break;
		  	  case 3:{dou=10;}break;
		  	  case 2:{dou=1;}break;
		  	  case 5:{dou=1000;}break;
		  	  case 6:{dou=10000;}break;
		  	  default: break;
		  }
		  if(average<ADzero)					//qt
		  {
			  gg=ADzero-average;				//AutozeroP_
			  if(gg<=2)
			  {
				  autozero=1;
				  g=0;
			  }
			  else
			  {
				  autozero=0;
				  nn=1;							//tXЬ1
				  buu=10*cn/resolution;
				  buu=buu*(ADzero-average);		//qt
				  buu=buu/dou*100;
				  buu=buu/gain;
				  gg=buu%10;															//45J
				  if(gg>5) buu+=10;
				  g=buu/10;
				  g=g*resolution;
			  }
		  }
		  else
		  {
			  gg=average-ADzero;				//q
			  if(gg<=2)							//AutozeroP_
			  {
				  autozero=1;
				  g=0;
			  }
			  else
			  {
				  autozero=0;
				  nn=0;							//tXЬ0
				  buu=10*cn/resolution;
				  buu=buu*(average-ADzero);				//qt
				  buu=buu/dou*100;
				  buu=buu/gain;
				  gg=buu%10;															//45J
				  if(gg>5) buu+=10;
				  g=buu/10;
				  g=g*resolution;
			  }
		  }
		  if(tare==1)
		  {
			  g=g-tareg;														//x
			  if(g<0)														//xX{t
			  {
				  g=g*-1;
				  nn=1;
			  }
			  else nn=0;
		  }
		  if(g==0) nn=0;
		  LCD_DATA_DISPLAY(g);												//ܭq

	  }
}
void scalse_cn(void)								//ū׮եƵ{
{
	DrvADC_Enable();								//}ADC
	nn=0;
	autozero=0;
	tare=0;
	intest=1;
	ClearLCDframe();
	LCD_DATA_DISPLAY(555555);Delay(0x10000);
	LCD_DATA_DISPLAY(444444);Delay(0x10000);
	LCD_DATA_DISPLAY(333333);Delay(0x10000);
	LCD_DATA_DISPLAY(222222);Delay(0x10000);
	LCD_DATA_DISPLAY(111111);Delay(0x10000);										//եX
	ADnum=6;										//w]k
	c=2;
	LED=ADnum;
	int o;
	while(c)
	{
		AD01();										//IsADCƵ{
		LCD_DATA_DISPLAY(average);					//ܲ{bADC
		TCH=3;ScanKey4(TCH);						//ytouch key1.2.4
		TCH=0;ScanKey4(TCH);
		TCH=1;ScanKey4(TCH);
		o=ADnum-LED;
		if(o==0)	asm("NOP");
		else
		{
			ADnum=LED;								//zLtouch key1.2LEDϥkƧ
			if(LED>16) LED=0;
			ADnumber=24-ADnum;						//NkƧאּADCϥbit
			LCD_DATA_DISPLAY(ADnumber);				//bit
			Delay(0x1f700);
		}
		Delay(0x2000);
	}
	ADnumber=24-ADnum;
	ClearLCDframe();
	Delay(0x1ffff);
	unsigned char lcd1,lcd2,lcd3,lcd4;
	nu=1;											//]w̤j
	lcd1=8;											//w]̤j8000g
	lcd2=lcd3=lcd4=0;
	c=2;
	first=1;
	while(c)
	{
		 for(TCH=0;TCH<4;TCH++){ScanKey4(TCH);}		//yyouch key
		 LCD_DATA_DISPLAY1(lcd1);
		 LCD_DATA_DISPLAY2(lcd2);
		 LCD_DATA_DISPLAY3(lcd3);
		 LCD_DATA_DISPLAY4(lcd4);
		 switch(nu)
		 {
		 	 case 1:{if(first==1){first=0;LED=lcd1;}if(LED>10)LED=0;lcd1=LED;}break;	//Oܭ+1
		 	 case 2:{if(first==1){first=0;LED=lcd2;}if(LED>10)LED=0;lcd2=LED;}break;	//Oܭ-1
		 	 case 3:{if(first==1){first=0;LED=lcd3;}if(LED>10)LED=0;lcd3=LED;}break;	//ܱܭ
		 	 case 4:{if(first==1){first=0;LED=lcd4;}if(LED>10)LED=0;lcd4=LED;}break;	//T{
		 }
		 if(enter>=1)
		 {
			 enter=0;
			 nu++;						//ܱܭ
			 first=1;
			 if(nu>=5) nu=1;
		 }
		 Delay(0x7f00);
	}
	max=(lcd1*1000)+(lcd2*100)+(lcd3*10)+lcd4;			//[`AsJ̤jȦs
	ClearLCDframe();
	Delay(0x1f000);										//]wkXեq
	lcd1=5;												//w]5000g
	lcd2=lcd3=lcd4=0;
	c=2;
	nu=1;
	first=1;
	while(c)
	{
		 for(TCH=0;TCH<4;TCH++){ScanKey4(TCH);}
		 LCD_DATA_DISPLAY1(lcd1);
		 LCD_DATA_DISPLAY2(lcd2);
		 LCD_DATA_DISPLAY3(lcd3);
		 LCD_DATA_DISPLAY4(lcd4);
		 switch(nu)
		 {
		 	 case 1:{if(first==1){first=0;LED=lcd1;}if(LED>10)LED=0;lcd1=LED;}break;	//Oܭ+1
		 	 case 2:{if(first==1){first=0;LED=lcd2;}if(LED>10)LED=0;lcd2=LED;}break;	//Oܭ-1
		 	 case 3:{if(first==1){first=0;LED=lcd3;}if(LED>10)LED=0;lcd3=LED;}break;	//ܱܭ
		 	 case 4:{if(first==1){first=0;LED=lcd4;}if(LED>10)LED=0;lcd4=LED;}break;	//T{
		 }
		 if(enter>=1)
		 {
			 first=1;
			 enter=0;
			 nu++;						//ܱܭ
			 if(nu>=5) nu=1;
		 }
		 Delay(0xff00);
	}
	cn=(lcd1*1000)+(lcd2*100)+(lcd3*10)+lcd4;		//[`BAsJk®ե
	ClearLCDframe();
	Delay(0x1f000);
	next=0;											//sI۰ʧPíե
	c=2;
	int z;
	while(c)
	{
		TCH=3;ScanKey4(TCH);						//ĲNtouch key4j
		AD01();
		ADzero=average;
		LCD_DATA_DISPLAY(ADzero);
		Delay(0xf000);
		AD01();
		z=ADzero-average;									//s⦸ۦPhnext+1
		if(z==0)
		{
			next++;											//nextۦP3hP_IsI
		}
		else {next=0;}
		LCD_DATA_DISPLAY(ADzero);
		if(next>3) c=0;
	}
	next=0;											//եI۰ʧPíե
	c=2;
	ClearLCDframe();
	Delay(0x1f000);
	while(c)
	{
		AD01();
		if(average>(ADzero*115/100))
		{
			TCH=3;ScanKey4(TCH);							//ĲNtouch key4j
			AD01();
			ADcn=average;
			LCD_DATA_DISPLAY(ADcn);
			Delay(0xf000);
			AD01();
			z=ADcn-average;									//s⦸ۦPhnext+1
			if(z==0)
			{
				next++;											//nextۦP3hP_IsI
			}
			else {next=0;}
			LCD_DATA_DISPLAY(ADcn);
			if(next>3) c=0;
		}
	}
	ClearLCDframe();
	Delay(0x1f000);
	lcd1=1;													//w]׬1
	lcd2=3;													//w]pIIb3
	lcd3=ADnumber/10;										//ADCϥbit
	lcd4=ADnumber%10;
	nu=1;
	c=2;
	first=1;
	while(c)
	{
		for(TCH=0;TCH<4;TCH++){ScanKey4(TCH);}
		LCD_DATA_DISPLAY1(lcd1);
		LCD_DATA_DISPLAY2(lcd2);
		LCD_DATA_DISPLAY3(lcd3);
		LCD_DATA_DISPLAY4(lcd4);
		switch(nu)
		{
			case 1:{if(first==1){first=0;LED=lcd1;}if(LED>10)LED=0;lcd1=LED;}break;
			case 2:{if(first==1){first=0;LED=lcd2;}if(LED>=6)LED=0;lcd2=LED;}break;
		}
		if(enter>=1)
		{
			enter=0;
			nu++;
			first=1;
			if(nu>=3) nu=1;
		}
		Delay(0xff00);
	}											//}եҦ
	resolution=lcd1;										//sǫ
	decimal=7-lcd2;											//spI
	gain=ADcn-ADzero;
	DrvADC_DisableInt();					//ADC_
	DrvFlash_Burn_Word(0x8004,0x600,decimal); 	//NեȿNJFlash
	DrvFlash_Burn_Word(0x8008,0x600,ADnum);
	DrvFlash_Burn_Word(0x800c,0x600,resolution);
	DrvFlash_Burn_Word(0x8010,0x600,ADzero);
	DrvFlash_Burn_Word(0x8014,0x600,ADcn);
	DrvFlash_Burn_Word(0x8018,0x600,cn);
	DrvFlash_Burn_Word(0x8030,0x600,gain);
	DrvADC_EnableInt();						//}_ADC_
	ClearLCDframe();
	Delay(0xffff);
	touch_ct();

}
/*------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{
  unsigned char I2C_Status;

  if(DrvI2C_ReadIntFlag()==E_DRVI2C_INT)  // Get I2C Interrupt Flag
  {
    I2C_Status=DrvI2C_GetStatusFlag();  // Get I2C Status Flag
    switch(I2C_Status)
    {
      case 0x90: //MACTFlag+RWFlag
          { /* START has been transmitted */
            DrvI2C_WriteData(I2C_TARGET);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x84: //MACTFlag+ACKFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x80: //MACTFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x30:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
      case 0x8C: // MACTFlag+DFFlag+ACKFlag
          { /* DATA has been transmitted and ACK has been received */
            if(DataTxIndex<DataTxLen)
            {
              DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              if(I2C_RW == WRITE)
              {
                DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
                EndFlag=1;
              }
              else if(I2C_RW == READ)
                DrvI2C_Ctrl(1,0,0,0);  // I2C as master sends START signal
              DataTxIndex=0;
            }
            break;
          };
      case 0x88: //MACTFlag+DFFlag
          { /* DATA has been transmitted and NACK has been received */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            DataTxIndex=0;
            EndFlag=1;
            break;
          };
      case 0xB0:
          { /* A repeated START has been transmitted. */
            DrvI2C_WriteData(I2C_TARGET | READ);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          }
      case 0x94: //MACTFlag+RWFlag
          { /* Slave A + R has been transmitted. ACK has been received. */
            DrvI2C_Ctrl(0,0,0,1);  // Set ACK bit
            break;
          };
      case 0x9C: //MACTFlag+RWFlag+DFFlag+ACKFlag
          { /* Data byte has been received. ACK has been transmitted. */
            if(DataRxLen>DataRxIndex)
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
              EndFlag=1;
            }
            break;
          };
      case 0x98: //MACTFlag+RWFlag+DFFlag
          { /* Data byte has been received. NACK has been transmitted. */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            EndFlag=1;
            break;
          };
      default:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
    }
    DrvI2C_ClearEIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CIF)
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
  if(DrvI2C_ReadIntFlag()==E_DRVI2C_ERROR_INT)  //Get I2C Error Interrupt Flag
  {
    EndFlag=1;
    DrvI2C_ClearIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CEIF)
    DrvI2C_Ctrl(0,1,0,0);   // I2C as master sends STOP signal
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
}

/*---------------------------------------------------------------------------*/
/* WDT & RTC & Timer A/B/C Interrupt Service Routines                                         */
/*---------------------------------------------------------------------------*/
void HW1_ISR(void)
{
	  DrvTIMER_ClearIntFlag(E_TMA);	        //Clear TMA interrupt flag
	  t=1;
	  asm volatile("sethi $r0, 0xc0000");				//w_iw
	  asm volatile("ori  $r0, $r0, 0x003f");
	  asm volatile("mtsr $r0, $INT_MASK");
	  asm volatile("movi $r0, 0x70009");
	  asm volatile("mtsr $r0, $PSW");
}

/*----------------------------------------------------------------------------*/
/* HW2 ADC Interrupt Subroutines                                              */
/*----------------------------------------------------------------------------*/
void HW2_ISR(void)
{
	  DrvADC_ClearIntFlag();				//MAD_X
	  ADCData=adc_08;
	  ADCData=ADCData>>8;
	  ok=1;
	  asm volatile("sethi $r0, 0xc0000");				//w_iw
	  asm volatile("ori  $r0, $r0, 0x003f");
	  asm volatile("mtsr $r0, $INT_MASK");
	  asm volatile("movi $r0, 0x70009");
	  asm volatile("mtsr $r0, $PSW");
}

/*---------------------------------------------------------------------------*/
/* CMP/OPA Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW3_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* PT1 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW4_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* PT2 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW5_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* Software Delay Subroutines                                                */
/*---------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
  for(;num>0;num--)
    asm("NOP");
}
void AD01(void)									//ADCƵ{
{
	unsigned char t;
	while(ok)									//ADC_OK=1
	{
		ok=0;
		ADtemp10=(ADCData>>ADnum);

		value_buf[8]=value_buf[7];				//ưoiBz
		value_buf[7]=value_buf[6];
		value_buf[6]=value_buf[5];
		value_buf[5]=value_buf[4];
		value_buf[4]=value_buf[3];
		value_buf[3]=value_buf[2];
		value_buf[2]=value_buf[1];
		value_buf[1]=ADtemp10;
		sum=0;
		for(t=4;t>0;t--)
		{
			sum+=value_buf[t];
		}
		average=sum>>2;
	}
}
int ScanKey4(unsigned int TCH)						//touch keyƵ{
{
  CL=TCH;pio_00=0x0100;								//qeq
  DrvTMB_ClearTMB();								//TMBpks
  DrvCMP_EnableNonOverlap(CL);						//ܥRqqD
  cmpresult=DrvCMP_ReadData();						//ŪX
  while(cmpresult==1){cmpresult=DrvCMP_ReadData();}	//TwXϦV
  tmrbcnt=DrvTMB_CounterRead();//TMB				//P_RqɶO_C֭
  switch(CL)
  {
    case 0 : if(tmrbcnt<=threh0){LED++;}break;
    case 1 : if(tmrbcnt<=threh1){LED--;}break;
    case 2 : if(tmrbcnt<=threh2){enter++;}break;
    case 3 : if(tmrbcnt<=threh3){c--;}break;
    default: break;
  }
  pio_00=0x0101;									//qeRq
  pio_04=0x0100;
  return 0;
}
void touch_ct(void)								//touch keyեƵ{
{
	int z,y;

		 LCD_DATA_DISPLAY(888888);
		 Delay(0x8000);
		 unth0=0;								//touch1 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=0;ScanKey4(TCH);
			 unth0+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth0=unth0>>3;
		 LCD_DATA_DISPLAY(000000);
		 unth1=0;								//touch2 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=1;ScanKey4(TCH);
			 unth1+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth1=unth1>>3;
		 LCD_DATA_DISPLAY(888888);
		 unth2=0;								//touch3 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=2;ScanKey4(TCH);
			 unth2+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth2=unth2>>3;
		 LCD_DATA_DISPLAY(000000);
		 unth3=0;								//touch4 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=3;ScanKey4(TCH);
			 unth3+=tmrbcnt;
			 Delay(0xfff);
		 }
		 unth3=unth3>>3;
		 LCD_DATA_DISPLAY(991111);
		 th0=0;									//touch1 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=0;ScanKey4(TCH);
			 if(tmrbcnt<435)
			{
				 y--;
				 th0+=tmrbcnt;
			}
		 }
		 th0=th0>>3;
		 LCD_DATA_DISPLAY(992222);
		 th1=0;									//touch2 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=1;ScanKey4(TCH);
			 if(tmrbcnt<220)
			 {
			 	y--;
			 	th1+=tmrbcnt;
			 }
		 }
		 th1=th1>>3;
		 LCD_DATA_DISPLAY(993333);
		 th2=0;									//touch3 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=2;ScanKey4(TCH);
			 if(tmrbcnt<180)
			 {
				 y--;
				 th2+=tmrbcnt;
			 }
		 }
		 th2=th2>>3;
		 LCD_DATA_DISPLAY(994444);
		 th3=0;									//touch4 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=3;ScanKey4(TCH);
			 if(tmrbcnt<180)
			 {
				 y--;
				 th3+=tmrbcnt;
			 }
		 }
		 th3=th3>>3;
		 threh0=unth0-(((unth0-th0)*3)/4);		//pե
		 threh1=unth1-(((unth1-th1)*3)/4);
		 threh2=unth2-(((unth2-th2)*3)/4);
		 threh3=unth3-(((unth3-th3)*3)/4);
		 LED=0;
		 enter=0;
		 DrvADC_DisableInt();					//ADC_
		 DrvTIMER_DisableInt(E_TMA);			//TMA_
		 DrvFlash_Burn_Word(0x801c,0x600,0x11100);		//NP_O_եLμƭȿNJFlash
		 DrvFlash_Burn_Word(0x802c,0x600,threh0);		//NեȦsJFlash
		 DrvFlash_Burn_Word(0x8020,0x600,threh1);
		 DrvFlash_Burn_Word(0x8024,0x600,threh2);
		 DrvFlash_Burn_Word(0x8028,0x600,threh3);
		 Delay(0x8000);
		 DrvTIMER_EnableInt(E_TMA);				//}TMA_
		 DrvADC_EnableInt();					//}ADC_
		 intest=0;
}
void Ini_Touch(void)
{
  DrvCMP_Enable();                                //CMP enable
  DrvCMP_Open(1,1,1);                             //CMP open
  DrvCMP_PInput(0);                               //Comparator positive input  CH1
  DrvCMP_NInput(3);                               //Comparator negative input  RLO
  DrvCMP_RLO_refV(2,1);
  DrvCMP_DisableNonOverlap();
  DrvCMP_RLO_Ctrl(0,1);
  DrvCMP_InputSwitch(1);
  DrvCMP_InputSwitch(0);
  DrvCMP_RLO_Ctrl(1,0);
  DrvTMB_ClearTMB();
  DrvCLOCK_SelectIHOSC(0x00);
  DrvCLOCK_SelectMCUClock(0,0);                   //select MCU clock as LS_CK,div1
  DrvTMBC_Clk_Source(1,3);//(1,0)                 //TimerB Clock enable pre_scale 1
  DrvTMB_Open(E_TMB_MODE0,E_TMB_CMP_HIGH,0xffff); //TimerB overflow 0xffff->PWM period 0xffff
  DrvTMB_ClearTMB();
  //Set VDDA voltage
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);                    //ADC analog ground source selection.
                                                  //1 : Enable buffer and use internal source(need to work with ADC)
  DrvPMU_LDO_LowPower(Enable);                    //VDD LDO with low power control.//0 : Normal;1 : Low power
  Delay(0x1000);
}
/*---------------------------------------------------------------------------*/
void InitalADC(void)
{
  //Set ADC input pin
  DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);//ADC Input
  DrvADC_InputSwitch(OPEN);
  DrvADC_RefInputShort(OPEN);
  DrvADC_Gain(7,3);          //Set the ADC Gain
  DrvADC_DCoffset(0);        //DC offset input voltage selection
  DrvADC_RefVoltage(VDDA,0); //Set the ADC reference voltage.
  DrvADC_FullRefRange(1);    //Set the ADC reference range select.
                             //0:Full reference range input
                             //1:1/2 reference range input
  DrvADC_OSR(0);             //0:OSR=32768
  DrvADC_CombFilter(Enable);
  DrvADC_ClkEnable(0,1);     //Setting ADC CLOCK ADCK=HS_CK/6
  //Set VDDA voltage
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);//ADC analog ground source selection.
                              //1:Enable buffer and use internal source
  DrvPMU_LDO_LowPower(0);     //VDD LDO with low power control.
                              //0 : Normal;1 : Low power
  Delay(0x1000);
  //Set ADC interrupt
  DrvADC_EnableInt();
  DrvADC_ClearIntFlag();
  DrvADC_Enable();
}
void Initial_ALL(void)
{
	  pio_00=0xff00ff00;				  //TOSΪ}
	  pio_04=0xff00ff00;
	  pio_08=0x00;
	  pio_10=0xff00ff03;
	  pio_14=0xff00ff03;

	  autozero=0;						//]wX
	  LED=0;
	  t=0;
	  TCH=0;
	  c=0;
	  enter=0;
	  intest=0;


	  DrvTMA_Open(9,1);                   //TimerA Overflow
	                                      //9:taclk/1024/32;TMRDV=32
	                                      //00:HS_CK
	  DrvTIMER_ClearIntFlag(E_TMA);       //Clear Timer A interrupt flag
	  DrvTIMER_EnableInt(E_TMA);          //Timer A interrupt enable

	  DrvCLOCK_SelectIHOSC(0);
	  DrvCLOCK_EnableHighOSC(E_INTERNAL,50);       // Select HAO 4MHz
	  SYS_EnableGIE(7,0x3F);  // Enable GIE(Global Interrupt)
}
/*---------------------------------------------------------------------------*/
/* End Of File                                                               */
/*---------------------------------------------------------------------------*/
